#include <fstream.h>
#include <allegro.h>
#include "dfile.h"

DATAFILE* adata;

RGB* getpal()
{
	static RGB our_pal[256];
	DATAFILE* d=load_datafile("atlantis.dat");
	RGB* a_p=find_data(a, "WinPal")->dat;
	for (int i=0; i<256; ++i)
		our_pal[i]=pal[i];
	unload_datafile(d)
	return our_pal;
}
	
int main(int argc, char *argv[])
{
	allegro_init();
	BITMAP* bm=create_bitmap(256,256);
	BITMAP* tmp=create_bitmap(16,16);
	RGB* pal=getpal();
	for (int i=1; i<argc; ++i)
	{
		clear(bm);
		ifstream inp(argv[i]);
		char df_name[32];
		char dum[32];
		chat bm_name[32];
		inp >> df_name >> dum >> bm_name;
		adata=load_datafile(df_name);
		while(inp)
		{
			int i;
			char t[32];
			int a;
			inp>>i>>t>>a;
			if (inp)
			{
				RLE_SPRITE* cel=(RLE_SPRITE*) find_data(t)->dat;
				if (cel->w>tmp->w || cel->h>tmp->h)
				{
					destroy_bitmap(tmp);
					tmp=create_bitmap(cel->w, cel->h);
				}
				clear(tmp);
				draw_rle_sprite(tmp, cel, 0, 0);
				int x=(i%16)*16;
				int y=(i/16)*16;
				stretch_blit(tmp, bm, 0, 0, cel->w, cel->h, x, y, 16, 16);
			}
		}
		save_bitmap(bm_name, bm, pal);
		unload_datafile(adata);
	}
	// can't be bothered to clean up
	return 0;
}
